#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <unistd.h>
#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>

#include "adconfig.h"

extern FILE *yyin, *yyout;
extern int yyparse(void);

char *progname;

void version(void)
{
    printf("ADwin system setup for LINUX\n(c) %s Jaeger Messtechnik GmbH, Lorsch\n", COPYRIGHT_YEARS);
    printf("%s v%s (%s)\n", progname, VERSION, VERSION_DATE);
    exit(0);
}

int main(int argc, char **argv)
{
    int i, res;
    int fd[2];
    FILE *out;

    progname = argv[0];

    pipe(fd);

    out = fdopen(fd[1], "w");
    for (i = 1; i < argc; i++)
        fprintf(out, "%s\n", argv[i]);
    fclose(out);

    yyout = fopen("/dev/null", "w");
    yyin  = fdopen(fd[0], "r");
    res   = yyparse();

    fclose(yyin);
    fclose(yyout);

    return !res ? callback() : 1;
}

