
#ifndef __ETHERNET_H__
#define __ETHERNET_H__

__BEGIN_DECLS

#include <linux/adwin.h>
#include <libadwin/types.h>
#include <libadwin/bits.h>


long NET_Boot(adwin_dev_t *dev, int fd, const char *filename, long iboardsize);
int NET_Test_Version(adwin_dev_t *dev, int fd);
processor_type_t NET_Processor_Type(adwin_dev_t *dev, int fd, processor_type_t *processor);
int NET_Workload(adwin_dev_t *dev, int fd, int32_t priority, int32_t *value);
int NET_Free_Mem(adwin_dev_t *dev, int fd, int Mem_Spec, int32_t *value);

int NET_Load_Process(adwin_dev_t *dev, int fd, const char *filename);
int NET_Start_Process(adwin_dev_t *dev, int fd, int processID);
int NET_Stop_Process(adwin_dev_t *dev, int fd, int processID);
int NET_Clear_Process(adwin_dev_t *dev, int fd, int processID);
// NET_Process_Status, NET_Set_Globaldelay and NET_Get_Globaldelay are
// modeled by Get_Par and Set_Par

int NET_Set_Par(adwin_dev_t *dev, int fd, int index, int32_t value);
int NET_Get_Par(adwin_dev_t *dev, int fd, int index, int32_t *value);
int NET_Get_Par_All(adwin_dev_t *dev, int fd, int startIndex, int count, int32_t *dest);

int NET_Set_FPar(adwin_dev_t *dev, int fd, int index, float value);
int NET_Get_FPar(adwin_dev_t *dev, int fd, int index, float *value);
int NET_Get_FPar_All(adwin_dev_t *dev, int fd, int startIndex, int count, float *dest);

int NET_Set_FPar_Double(adwin_dev_t *dev, int fd, int index, double value);
int NET_Get_FPar_Double(adwin_dev_t *dev, int fd, int index, double *value);
int NET_Get_FPar_All_Double(adwin_dev_t *dev, int fd, int start_index, int count, double *dest);

long NET_Data_Length(adwin_dev_t *dev, int fd, long DataNo);
int NET_GetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *dest, int16_t type);
int NET_SetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *src, int16_t type);
int NET_GetData_String(adwin_dev_t *dev, int fd, int data_no, long max_count, void *dest);
int NET_SetData_String(adwin_dev_t *dev, int fd, int data_no, long max_count, const void *src);
int NET_String_Length(adwin_dev_t *dev, int fd, int data_no, int *dest);


int NET_Fifo_Empty(adwin_dev_t *dev, int fd, int fifono, int *dest);
int NET_Fifo_Full(adwin_dev_t *dev, int fd, int fifono, int *dest);
int NET_Fifo_Clear(adwin_dev_t *dev, int fd, int fifono);
int NET_SetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *src, int16_t type);
int NET_GetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *dest, int16_t type);
// todo: float, double?

// todo: Set/Get String, string length, getlasterror+text,

long __get_Version_TcpIp(adwin_dev_t *dev);

int NET_Get_Memory_dsp(adwin_dev_t *dev, int fd, int32_t base_addr, int32_t anzahl, int32_t *dest);

int NET_GetDataType(adwin_dev_t *dev, int fd, int datanr);
int NET_Clear_Data(adwin_dev_t *dev, int fd, int Datanr);

__END_DECLS

#endif /* __ETHERNET_H__ */
