****************************************
*	 Prozenummer = 1
*	 Delay = 400
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
' goldpwm4.bas  
' H.M.   22.06.1999   creation
' JK     19.09.2000   comment on accuracy
' JK     25.06.2001   comment on resolution
' R.Ra   16.03.2004   cnt_se_diff(3) added

'
' Demo-program for puls width measurement with ADwin-Gold
' In this mode the system can measure 4 Signals
' Maximum signal frequency is 100 kHz (= dependant on GLOBALDELAY)
' Connect Signal 1 to cntr#1 latch
' Connect Signal 2 to cntr#2 latch
' Connect Signal 3 to cntr#3 latch
' Connect Signal 4 to cntr#4 latch

' par_1  =   periodwidth for signal 1 in (50ns)
' par_2  =   periodwidth for signal 2 in (50ns)
' par_3  =   periodwidth for signal 3 in (50ns)
' par_4  =   periodwidth for signal 4 in (50ns)
' par_9  =   Pulse low time signal 1 (in 50 ns)
' par_10 =   Pulse low time signal 2 (in 50 ns)
' fpar_1 =   Pulse high / Pulsewidth  Signal 1
' fpar_2 =   Pulse high / Pulsewidth  Signal 2

' The resolution of the ADwin-GOLD-CO1 is 50 ns.  
' The accuracy of the ADwin-GOLD-CO1 with this program can be  
'  calculated with the following formula :
'         accuracy = +- 50 ns / signal_period_width * 100%
'
'     Example :       (signal_period_width = 1 millisecond)
'         accuracy = +- 0.005%
'     Note : This obviously does not include the accuracy of the
'            signal source itself (e.g. of the incremental encoder) 

#include adwgcnt.inc

dim ih, co1, co2, co3, co4 as integer
dim co1old, co2old, co3old, co4old as integer
dim co1f, co2f as integer

init:
GLOBALDELAY = 400		' sampling with 100 kHz
cnt_enable(0)           ' disable all counters
cnt_clear(15)           ' clear all counters
cnt_se_diff(3)				  ' all counters with diff. inputs
cnt_mode(15)            ' all counters  internal clock
cnt_set(0)              ' all counters 20 MHz
cnt_inputmode(15)       ' all counters latch input
cnt_enable(15)          ' enable all counters


event:
co1 =  cnt_readlatch(1)     
co2 =  cnt_readlatch(2)
co3 =  cnt_readlatch(3)
co4 =  cnt_readlatch(4)
co1f = cnt_readflatch(1)     
co2f = cnt_readflatch(2)     

if (co1 <> co1old) then 
  par_1 = co1 - co1old      ' calculate number of counts
  par_9 = co1 - co1f
  if (par_9 < 0) then par_9 = par_9 + par_1
  fpar_1 = 1 - par_9 / par_1
  co1old = co1
  endif
if (co2 <> co2old) then 
  par_2 = co2 - co2old      ' calculate number of counts
  par_10 = co2 - co2f
  if (par_10 < 0) then par_10 = par_10 + par_2
  fpar_2 = 1 - par_10 / par_2
  co2old = co2
  endif

if (co3 <> co3old) then 
  par_3 = co3 - co3old      ' calculate number of counts
  co3old = co3
  endif
if (co4 <> co4old) then 
  par_4 = co4 - co4old      ' calculate number of counts
  co4old = co4
  endif




