#ifndef __LIBADWIN_SCILAB_H__
#define __LIBADWIN_SCILAB_H__

#include <inttypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/* The scilab driver is basically just a bunch of wrapper functions
   with pass-by-reference parameters that call the regular libadwin.h
   functions.

   The code is far from being complete, but it is a proof of concept
   that shows how it works. Implementing the missing functions should
   be trivial.
*/
void sl_Boot(const char *filename);
void sl_Clear_Process(int32_t *process_no);
void sl_Data_Length(int32_t *data_no, int32_t *value);
void sl_Data2File(const char *filename, int32_t *data_no, int32_t *start_index, int32_t *count, int32_t *mode);
void sl_Fifo_Clear(int32_t *fifo_no);
void sl_Fifo_Empty(int32_t *fifo_no, int32_t *value);
void sl_Fifo_Full(int32_t *fifo_no, int32_t* value);
void sl_Free_Mem(int32_t *mem_spec, int32_t *value);
void sl_Get_FPar(int32_t *index, float* value);
void sl_Get_FPar_All(float dest[]);
void sl_Get_FPar_Block(float dest[], int32_t *start_index, int32_t *count);
void sl_Get_Last_Error (int32_t *error_number);
void sl_Get_Last_Error_Text(int32_t *error_number, char *error_text);
void sl_Get_Par(int32_t *index, int32_t *value);
void sl_Get_Par_All(int32_t dest[]);
void sl_Get_Par_Block(int32_t dest[], int32_t *start_index, int32_t *count);
void sl_Get_Processdelay(int32_t *process_no, int32_t *delay);
void sl_GetData_Float(int32_t *data_no, float dest[], int32_t *start_index, int32_t *count);
void sl_GetData_Long(int32_t *data_no, int32_t dest[], int32_t *start_index, int32_t *count);
void sl_GetData_String(int32_t *data_no, char dest[], int32_t *max_count);
void sl_GetFifo_Float(int32_t *fifo_no, float dest[], int32_t *count);
void sl_GetFifo_Long(int32_t *fifo_no, int32_t dest[], int32_t *count);
void sl_Load_Process(const char *filename);
void sl_Process_Status(int32_t *process_no, int32_t *status);
void sl_Processor_Type(int32_t *processor_type);
void sl_Set_DeviceNo(int32_t *device_no);
void sl_Set_FPar(int32_t *index, float *value);
void sl_Set_Par(int32_t *index, int32_t *value);
void sl_Set_Processdelay(int32_t *process_no, int32_t *process_delay);
void sl_SetData_Float(int32_t *data_no, float src[], int32_t *start_index, int32_t *count);
void sl_SetData_Long(int32_t *data_no, int32_t src[], int32_t *start_index, int32_t *count);
void sl_SetData_String(int32_t *data_no, char data[]);
void sl_SetFifo_Float(int32_t *fifo_no, float src[], int32_t *count);
void sl_SetFifo_Long(int32_t *fifo_no, int32_t src[], int32_t *count);
void sl_Start_Process (int32_t *process_no);
void sl_Stop_Process (int32_t *process_no);
void sl_String_Length(int32_t *data_no, int32_t *length);
void sl_Test_Version(int32_t *value);
void sl_Workload(int32_t *priority, int32_t *workload);



#ifdef __cplusplus
}
#endif

#endif /* __LIBADWIN_SCILAB_H__ */
